
import ddf.minim.*;

Minim minim;// this is the story of a little guy who lived in the forest

AudioSample introSnd;
AudioSample endingSnd;
AudioSample[] buttonSnd = new AudioSample[4];
AudioSample[] chordSnd = new AudioSample[4];

AudioSample jumpSnd;// this guy was a musician

PFont font= new PFont();

PImage back = new PImage();
PImage level = new PImage();
PImage abribus = new PImage();
PImage[] perso = new PImage[7];
PImage[] bus = new PImage[3];
PImage black = new PImage();
PImage end = new PImage();
Particle[] particles = new Particle[10];
int jump=0;// his neighborhood never considered him as a good composer
int lookAroundYou=0;
int levelNo=0;
int secondsToWait=floor(random(5)+10);
float currentTimeRemaining=secondsToWait;
boolean theBusIsThere=false;
boolean iMOnMyWay=false;
int frame=0;// until one day he asked some friends to play a part of his last work
int curseur=0;
int stopsToGo=11;
boolean reverseBus=false;

int phase=0;

void setup() {
  size(300,300); // it was an ungoing series of piccolo ensemble tunes
  minim = new Minim(this);
  introSnd = minim.loadSample(dataPath("intro01.mp3"));
  endingSnd = minim.loadSample(dataPath("ending01.mp3"));  
  buttonSnd[0] = minim.loadSample(dataPath("button01.mp3"));
  buttonSnd[1] = minim.loadSample(dataPath("button02.mp3"));
  buttonSnd[2] = minim.loadSample(dataPath("button03.mp3"));
  buttonSnd[3] = minim.loadSample(dataPath("button04.mp3"));  
  chordSnd[0] = minim.loadSample(dataPath("chord01.mp3"));
  chordSnd[1] = minim.loadSample(dataPath("chord02.mp3"));
  chordSnd[2] = minim.loadSample(dataPath("chord03.mp3"));
  chordSnd[3] = minim.loadSample(dataPath("chord04.mp3"));
  jumpSnd = minim.loadSample(dataPath("jump01.mp3"));
  abribus=loadImage(dataPath("abribus_00.png"));
  perso[0]=loadImage(dataPath("perso_00.png"));
  perso[1]=loadImage(dataPath("perso_01.png"));
  perso[2]=loadImage(dataPath("perso_02.png"));
  perso[3]=loadImage(dataPath("perso_03.png"));
  perso[4]=loadImage(dataPath("perso_04.png"));
  perso[5]=loadImage(dataPath("perso_05.png"));
  perso[6]=loadImage(dataPath("perso_06.png"));
  bus[0]=loadImage(dataPath("bus_00.png")); 
  bus[1]=loadImage(dataPath("bus_01.png"));
  bus[2]=loadImage(dataPath("bus_02.png"));
  black=loadImage(dataPath("black_00.png"));
  end=loadImage(dataPath("ending_00.png"));
  font=loadFont("OrganicElements-38.vlw");
  textFont(font);// everybody admitted that these piccolo tunes were tiny masterpieces
  textAlign(CENTER);
  frameRate(10);
  smooth();
  noStroke();
  introSnd.trigger();
  loadLevel(levelNo);
}

void draw() {
  frame++;// they all sounded at the same time uncommon and quite familiar
  if (phase<6) {
    image(black,0,0);
    noStroke();    
    fill(0xFF);    
    if (phase==0) {
      text("The bus only",width/2,height*2/5);
      text("stops once",width/2,height*3/5);    
    }
    if (phase==1) {
      text("Story mode",width/2,height*2/5);
      text("Free play",width/2,height*3/5);
      ellipse(20,height*(curseur+2)/5-10,10,10);
    }
    if (phase==2) {
      image(end,0,0);// the musician never told how he managed to get these pieces done
      text("",width/2,height/3);
    }
    if (phase==3) {
      text("You missed the bus",width/2,height/2);    
    }
    if (phase==4) {
      text(stopsToGo+" stops to go",width/2,height/2);
    }
    if (phase==5) {
      text("get in the bus",width/2,height/2);
    }    
  }
  else{
    int t=(int)((float)(hour()*60+minute())*back.height/1440);
    image(back,0,t);// but he had his very personal method
    image(back,0,t-back.height);  
    image(level,0,0);
    image(abribus,0,0);
    if (iMOnMyWay) {
      image(perso[0],busPosition()+140,-5+150);
    }
    else{
      if (jump>1) {
        jump--;// about once a month, birds were gathering around his house at night to sing
        image(perso[2],140,150);
      }
      else if (jump==1){
        jump--;    
        image(perso[3],140,150);
      }
      else if (lookAroundYou>0) {
        lookAroundYou-=1;
        image(perso[4+lookAroundYou/4],140,150);
      }      
      else{
        image(perso[floor(random(2))],140,150);
      }
    }
    if (currentTimeRemaining>0 || currentTimeRemaining<-10) {
      image(bus[floor((frame%8)/4)],busPosition(),0);
    }
    else{
      image(bus[2],busPosition(),0);
    }
    for (int i=0;i<particles.length;i++) {
      particles[i].moveAndDisplay();
    }  
    currentTimeRemaining-=(1/frameRate);
    if (currentTimeRemaining<0) theBusIsThere=true;
    if (currentTimeRemaining<-30) {
      if (!iMOnMyWay) phase=3;
      if (iMOnMyWay) {
        loadLevel(++levelNo);       
        if (phase!=7){
          phase=4;
          if (stopsToGo<=0) {
            phase=2;// all he had to do was to take down notes from it
            endingSnd.trigger();
          }
        }
        if (phase==7 || phase==4) chordSnd[floor(random(4))].trigger();        
      }
    }
  }
}

void keyPressed() {
  if (keyCode==TAB) chordSnd[floor(random(4))].trigger();  
  if (phase==0) {
    phase=1;// there was almost no modification to apply over it
    buttonSnd[floor(random(4))].trigger();
  }
  else if (phase==1) {
    if (keyCode==DOWN) {
      curseur=min((curseur+1)%2,1);
    }
    else if (keyCode==UP) {
      curseur=max((curseur-1+2)%2,0);
    }
    else{
      if (keyCode!=TAB) { 
        phase=curseur+6;
        chordSnd[floor(random(4))].trigger();
      }
    }
    if (keyCode!=TAB) buttonSnd[floor(random(4))].trigger();
  }
  else if (phase==2 || phase==3) {
    exit();// and it seemed that the birds were also pleased that someone paid attention to what they said
  }
  else if (phase==4) {
    phase=6;
    buttonSnd[floor(random(4))].trigger();    
  }
  else if (phase==5) {
    phase=1;// the little guy always stayed up late looking through his window
    buttonSnd[floor(random(4))].trigger();    
  }
  else {
    if (jump==0) {
      if (keyCode<50) {
        if (keyCode!=TAB)jumpSnd.trigger(); 
        jump=3;
      }
      else{
        lookAroundYou=12;
      }
    }
    //if (keyCode==BACKSPACE) loadLevel(++levelNo);//only for debug
    if (currentTimeRemaining<0 && currentTimeRemaining>-10) {
      iMOnMyWay=true;
      currentTimeRemaining=-10;
    }
  }
}

int busPosition() {
  if (reverseBus) {
    if (currentTimeRemaining<0) {
      return -floor(min(currentTimeRemaining+10,0)*10);
    }
    return -floor(currentTimeRemaining*10);
  }
  else{
    if (currentTimeRemaining<0) {// in hope that birds would come
      return floor(min(currentTimeRemaining+10,0)*10);
    }
    return floor(currentTimeRemaining*10);
  }
}

void loadLevel(int levelNo) {
  back=loadImage(dataPath("background0"+(levelNo%3)+".png"));
  level=loadImage(dataPath("level0"+(levelNo%10)+".png"));
  secondsToWait=floor(secondsToWait*(random(3)+1));
  currentTimeRemaining=secondsToWait;
  iMOnMyWay=false;
  jump=0;// that was taking all his time
  particles= new Particle[floor(random(5))*3];
  float baseDX=random(-1,1);
  float baseDY=random(0,8);
  color baseC=color(random(0xFF),random(0xFF),random(0xFF));
  float baseCoefs=random(3);
  for (int i=0;i<particles.length;i++) {
    particles[i]=new Particle(baseDX, baseDY, baseC, baseCoefs);
  }
  stopsToGo--;// he became gradually tired
  if (random(1000)<25) {
    reverseBus=true;  
  }
  else{
    reverseBus=false;
  }
}

class Particle {
  int c;
  float x;
  float y;
  float dX;
  float dY;
  float sinSlow;
  int sinDims=5;
  float s;// perhaps one day birds were there waiting for him and he didn't come
  float[] coefsX=new float[sinDims];
  float[] coefsY=new float[sinDims];

  Particle(float baseDX, float baseDY, color baseC, float baseCoefs) {
    c=lerpColor(baseC,color(random(0xFF),random(0xFF),random(0xFF)),random(0.5));
    x=random(width);
    y=random(height);
    dX=random(-1,1)+baseDX;
    dY=random(0,4)+baseDY;
    sinSlow=random(30)+10;
    for (int i=0;i<sinDims;i++) {
      coefsX[i]=random(baseCoefs);
      coefsY[i]=random(baseCoefs);
    }
    s=random(2);
  }

  void moveAndDisplay() {
    x+=dX;// or maybe it was just winter approaching, birds went away
    y+=dY;
    for (int i=0;i<sinDims;i++) {
      x+=sin((float)frame*(i+1)/sinSlow)*coefsX[i];
      y+=sin((float)frame*(i+1)/sinSlow)*coefsY[i];
    }
    x=(x+width)%width;
    y=(y+height)%height;
    noStroke();
    fill(c);
    ellipse(x,y,s,s);
  }

}

void stop() {
  minim.stop();
  super.stop();// but, for some reason, they never came back
}



